package handler

import (
	"context"
	"net/http"

	httpsrv "go.unistack.org/micro-server-http/v3"
	"go.unistack.org/pkgdash/internal/models"
	pb "go.unistack.org/pkgdash/proto"
)

func (h *Handler) HandlerList(ctx context.Context, req *pb.HandlerListReq, rsp *pb.HandlerListRsp) error {
	h.logger.Debug(ctx, "HandlerList handler start")

	packages, err := h.store.HandlerList(ctx, req)
	if err != nil {
		h.logger.Error(ctx, "error db response: %v", err)
		httpsrv.SetRspCode(ctx, http.StatusInternalServerError)
		return httpsrv.SetError(NewInternalError(err))
	}

	for _, hdlr := range packages {
		rsp.Handlers = append(rsp.Handlers, models.NewHandler(hdlr))
	}
	h.logger.Debug(ctx, "HandlerList handler stop")
	return nil
}
